<template>
    <div class="row q-py-md">
        <div class="col-12 team-user">
            <div class="row items-center">
                <div class="col-5 col-md-2 q-pa-lg">
                    <q-img
                        :src="state.member.user.imageUrl"
                        width="100%"
                        img-class="rounded-img"
                    />
                </div>
                <div class="col-7 col-md-6">
                    <div class="row">
                        <span
                            class="
                                col-12
                                row
                                helvetica-neue-medium
                                font-18
                                member-name
                            "
                        >
                            {{ state.member.user.name }}
                        </span>
                    </div>
                    <div class="row items-center">
                        <div
                            class="
                                col-12
                                helvetica-neue-medium
                                member-name
                                font-14
                                items-center
                            "
                        >
                            <q-icon
                                class="h-auto q-pa-xs"
                                name="fiber_manual_record"
                                color="orange"
                            />
                            {{ state.member.role?.name }}
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="row q-py-md">
        <div class="col-12 team-history">
            <!-- FILTER -->
            <div class="row q-pa-lg items-center">
                <div class="col-6 col-md-6 justify-between">
                    <div class="row justify-start">
                        <div class="col-md-1 col-2">
                            <q-icon
                                class="member-name"
                                @click="minusDate"
                                size="md"
                                name="chevron_left"
                            ></q-icon>
                        </div>
                        <div class="text-center col col-md-5">
                            <span class="helvetica-neue-medium date-name">
                                {{ state.date }}
                            </span>
                        </div>
                        <div class="col-md-1 col-2">
                            <q-icon
                                class="member-name"
                                @click="addDate"
                                size="md"
                                name="chevron_right"
                            ></q-icon>
                        </div>
                    </div>
                </div>
                <div class="col-6">
                    <q-btn
                        dense
                        color="primary"
                        size="lg"
                        no-caps
                        class="
                            float-right
                            border-radius-12
                            q-pt-md q-pb-md q-pl-lg q-pr-lg
                            font-14
                        "
                        label="Select Date"
                    >
                        <q-popup-proxy
                            @before-show="updateProxy"
                            transition-show="scale"
                            transition-hide="scale"
                        >
                            <q-date v-model="proxyDate">
                                <div
                                    class="
                                        row
                                        items-center
                                        justify-end
                                        q-gutter-sm
                                    "
                                >
                                    <q-btn
                                        label="Cancel"
                                        color="primary"
                                        flat
                                        v-close-popup
                                    />
                                    <q-btn
                                        label="OK"
                                        color="primary"
                                        flat
                                        @click="save"
                                        v-close-popup
                                    />
                                </div>
                            </q-date>
                        </q-popup-proxy>
                    </q-btn>
                </div>
            </div>

            <!-- LOGS -->
            <div
                class="row q-pa-lg items-center audit"
                ref="auditArea"
                @scroll="handleScroll"
                v-if="state.logs.length > 0"
            >
                <div class="col-12">
                    <div
                        class="
                            row
                            items-center
                            q-my-sm q-py-md q-px-lg
                            team-info
                        "
                        v-for="(logs, index) in state.logs"
                        :key="index"
                    >
                        <div class="col-md-2 col-12">
                            {{ logs.createdAt }}
                        </div>
                        <div class="col-md-7 col-12">
                            <span
                                class="
                                    col-12
                                    helvetica-neue-medium
                                    font-18
                                    member-name
                                "
                            >
                                {{ logs.action }}
                            </span>
                        </div>
                        <div class="col-md-3 col-12">
                            <q-btn
                                dense
                                color="primary"
                                size="md"
                                rounded
                                no-caps
                                class="
                                    float-right
                                    border-radius-17
                                    q-pt-sm q-pb-sm q-pl-lg q-pr-lg
                                    font-14
                                "
                                label="View"
                            />
                        </div>
                    </div>
                </div>
            </div>

            <div class="row col-12 text-center items-center audit" v-else>
                <div class="col-12">
                    <p>{{ $t('team.selectDate') }}</p>
                </div>
            </div>
        </div>
    </div>
</template>

<script lang="ts">
// @ts-ignore: Object is possibly 'null'.
import { useStore } from 'src/store';
import { defineComponent, reactive, ref, watch, onMounted } from 'vue';
import { date } from 'quasar';

export default defineComponent({
    name: 'MemberHistory',
    props: { member: { type: Object, required: true } },

    setup(props) {
        const store = useStore();
        const auditArea = ref<any>(null);
        const isLoading = ref(false);
        var currentTime = ref(date.formatDate(Date.now(), 'YYYY-MM-DD'));
        var proxyDate = ref(date.formatDate(Date.now(), 'YYYY-MM-DD'));
        let previousScroll = 0;

        let state = reactive({
            member: props.member,
            date: date.formatDate(currentTime.value, 'dddd DD'),
            nextDate: date.formatDate(currentTime.value, 'dddd DD'),
            logs: [] as any,
            paginate: [] as any,
            pages: 1
        });
        let updateProxy = () => {
            proxyDate.value = currentTime.value;
        };

        let addDate = () => {
            var nextDay = new Date(
                date.formatDate(currentTime.value, 'YYYY-MM-DD')
            );
            var currentDay = new Date(
                date.formatDate(currentTime.value, 'YYYY-MM-DD')
            );
            nextDay.setDate(currentDay.getDate() + 1);
            var nextDate = currentDay.setDate(nextDay.getDate() + 1);
            currentTime.value = date.formatDate(nextDay, 'YYYY-MM-DD');
            state.nextDate = date.formatDate(nextDate, 'YYYY-MM-DD');

            // convert to utc
            currentTime.value = new Date(currentTime.value).toISOString();
            state.nextDate = new Date(nextDate).toISOString();

            state.date = date.formatDate(nextDay, 'dddd DD');
        };

        let minusDate = () => {
            var prevDay = new Date(
                date.formatDate(currentTime.value, 'YYYY-MM-DD')
            );
            var currentDay = new Date(
                date.formatDate(currentTime.value, 'YYYY-MM-DD')
            );
            prevDay.setDate(currentDay.getDate() - 1);
            var nextDay = currentDay.setDate(prevDay.getDate() + 1);
            currentTime.value = date.formatDate(prevDay, 'YYYY-MM-DD');
            state.nextDate = date.formatDate(nextDay, 'YYYY-MM-DD');

            // convert to utc
            currentTime.value = new Date(currentTime.value).toISOString();
            state.nextDate = new Date(nextDay).toISOString();

            state.date = date.formatDate(prevDay, 'dddd DD');
        };

        let save = () => {
            currentTime.value = proxyDate.value;
            state.date = date.formatDate(currentTime.value, 'dddd DD');
            currentTime.value = date.formatDate(
                currentTime.value,
                'YYYY-MM-DD'
            );
            currentTime.value = new Date(currentTime.value).toISOString();

            var nextDay = new Date(
                date.formatDate(currentTime.value, 'YYYY-MM-DD')
            );
            nextDay.setDate(nextDay.getDate() + 1);
            state.nextDate = date.formatDate(nextDay, 'YYYY-MM-DD');
            state.nextDate = new Date(state.nextDate).toISOString();
        };

        watch(currentTime, async (currentValue) => {
            if (currentValue) {
                state.logs = [];
                state.pages = 1;
                await getAudit();
            }
        });

        const onLoad = (index: any, done: any) => {
            setTimeout(() => {
                if (state.pages == state.paginate.totalPage) {
                    done(true);
                } else if (state.pages > state.paginate.totalPage) {
                    done();
                } else {
                    state.pages = state.pages + 1;
                    getAudit();
                    done();
                }
            }, 2000);
        };

        const changeDate = () => {
            var prevDay = new Date(
                date.formatDate(currentTime.value, 'YYYY-MM-DD')
            );
            var currentDay = new Date(
                date.formatDate(currentTime.value, 'YYYY-MM-DD')
            );
            prevDay.setDate(currentDay.getDate() + 1);
            var nextDay = currentDay.setDate(prevDay.getDate() + 1);
            state.nextDate = date.formatDate(nextDay, 'YYYY-MM-DD');

            // convert to utc
            state.nextDate = new Date(nextDay).toISOString();
        };

        const getAudit = async () => {
            if (store.state.role.permissions.member?.auditLog) {

                let query = {
                    userId: state.member.user.id,
                    startDateTime: currentTime.value,
                    endDateTime: state.nextDate,
                    /* startDateTime: '2021-10-14',
                    endDateTime: '2021-10-15', */
                    page: state.pages,
                    limit: 20
                };
                const result: any = await store.dispatch('user/getAudit', query);

                if (result.auditLogs.length > 0) {
                    result.auditLogs.forEach((element: any) => {
                        element.createdAt = date.formatDate(
                            element.createdAt,
                            'YYYY-MM-DD'
                        );
                        state.logs.push(element);
                    });

                    state.paginate = result.pagination;
                } else {
                    state.paginate.totalPage = 0;
                }
            }
        };

        const handleScroll = async () => {
            const currentScroll: number = auditArea.value?.scrollTop ?? 0;
            const maxScroll: number = auditArea.value?.scrollHeight ?? 0;
            const pageHeight: number = auditArea.value?.offsetHeight ?? 0;

            try {
                if (previousScroll < currentScroll) {
                    if (currentScroll + pageHeight > 0.95 * maxScroll) {
                        isLoading.value = true;

                        if (state.pages < state.paginate.totalPage) {
                            state.pages = state.pages + 1;
                            await getAudit();
                            isLoading.value = false;
                        }
                    }
                }
            } catch (err: any) {}

            previousScroll = currentScroll;
        };

        // mounted
        onMounted(changeDate);
        onMounted(getAudit);

        return {
            state,
            store,
            auditArea,
            currentTime,
            proxyDate,
            updateProxy,
            save,
            minusDate,
            addDate,
            getAudit,
            onLoad,
            handleScroll,
            changeDate
        };
    }
});
</script>
